Subject: Re: [PATCH 0/4] Netfilter ingress support (v3)

From: Pablo Neira Ayuso <[email-masked]>
Date: Tue, 5 May 2015 00:21:31 +0200

On Mon, May 04, 2015 at 01:05:08PM -0700, Alexei Starovoitov wrote:
> [...] TC critical path becomes slower with extra dereference and
> indirect jump.

You complained on the performance impact of the initial generic hook
infrastructure that allows qdisc ingress and nft to co-exist, fair
enough.

I came back with an even more simple hook infrastructure, to address
performance concerns, and you indicate that an *extra dereference and
indirect jump* makes this slowier and that both cannot co-exist with
this.

Well, any kind of hook generalization will need at least those minimal
changes. And that allows us to move code that belongs to sch_ingress.
That got embedded into net/core/dev.c because at the time this code
was made when there was no RCU around.

This sounds as an excuse to me.